NNRPD(8)

NAME
nnrpd - NNTP server for on-campus hosts

SYNOPSIS
nnrpd [ -r reason ] [ -s title padding ] [ -S host ] [ -t ]

DESCRIPTION
Nnrpd is an NNTP server for newsreaders. It accepts commands on its standard input and responds on its standard output. It is normally invoked by innd(8) with those descriptors attached to a remote client connection.

Unlike innd, nnrpd supports all NNTP commands for user-oriented reading and posting.

Nnrpd uses the nnrp.access(5) file to control who is authorized to access the Usenet database. It will also reject connections if the load average is greater than 10.

On exit, nnrpd will report usage statistics through syslog(3).

Nnrpd can accept multimedia postings that follow the MIME standard as long as such postings are also acceptible as SMTP messages. See the discussion of the MIME headers in inn.conf(5).

OPTIONS

-r  If the ``-r'' flag is used, then nnrpd will reject the incoming connection giving reason as the text. This flag is used by innd when it is paused or throttled.

-s  As each command is received, nnrpd tries to change its ``argv'' array so that ps(1) will print out the command being executed. To get a full display, the ``-s'' flag may be used with a long string as its argument, which will be overwritten when the program changes its title.

-t  If the ``-t'' flag is used then all client commands and initial responses will be traced by reporting them in syslog. This flag is set by innd under the control of the ctlinnd(8) ``trace'' command, and is toggled upon receipt of a SIGHUP; see signal(2).

-S  If the ``-S'' flag is used, then all postings are forwarded to the specified host, which should be the master NNTP server. This flag is set by innd if it is started with the ``-S'' flag.

  PROTOCOL DIFFERENCES
Nnrpd implements the NNTP commands defined in RFC 977, with the following differences:

1.  The ``ihave'' command is not implemented. Users should be using the ``post'' command to post articles.

2   The ``slave'' command is not implemented. This command has never been fully defined.

3   The ``list'' command may be followed by the optional word ``active.times'', ``distributions'', ``distrib.pats'', ``newsgroups'', ``subscriptions'', or ``overview.fmt'' to get a list of when newsgroups where created, a list of valid distributions, a file specifying default distribution patterns, a one-per-line description of the current set of newsgroups, a list of the automatic group subscriptions, or a listing of the overview.fmt(5) file. The command ``list active'' is equivalent to the ``list'' command. This is a common extension.

4.  The ``xhdr'', ``authinfo user'', and ``authinfo pass'' commands are implemented. These are based on the reference Unix implementation; no other documentation is available.

5.  A new command, ``xpat header range|MessageID pat [morepat...]'', is provided. The first argument is the case-insensitive name of the header to be searched. The second argument is either an article range or a single Message-ID, as specified in RFC 977. The third argument is a wildmat(3)-style pattern; if there are additional arguments they are joined together separated by a single space to form the complete pattern. This command is similar to the ``xhdr'' command. It returns a 221 response code, followed by the text response of all article numbers that match the pattern.

6.  The ``listgroup group'' command is provided. This is a comment extension. It is equivalent to the ``group'' command, except that the reply is a multi-line response containing the list of all article numbers in the group.

7.  The ``xgtitle [group]'' command is provided. This extension is used by ANU-News. It returns a 282 reply code, followed by a one-line description of all newsgroups that match the pattern. The default is the current group.

8.  The ``xover [range]'' command is provided. It returns a 224 reply code, followed by the overview data for the specified range; the default is to return the data for the current article.

9.  The ``xpath MessageID'' command is provided; see innd(8).

10. The ``date'' command is provided; this is based on the draft NNTP protocol revision. It returns a one-line response code of 111 followed by the GMT date and time on the server in the form YYYYMMDDhhmmss.

HISTORY
Written by Rich $alz <rsalz@uunet.uu.net> for InterNetNews. Overview support added by Rob Robertston <rob@violet.berkeley.edu> and Rich in January, 1993.

SEE ALSO
ctlinnd(8), innd(8), inn.conf(5), nnrp.access(5), signal(2), wildmat(3).